#include <iostream>
#include <string>
#include <vector>

using namespace std;
long long zamena(long long n, string niz01, long long cena){
    long long isplativost1, mini, c, l, r, i, j, d;
    c = 0;
    mini = 0;
    while(mini < cena)
    {
        for(i = 0; i < n; i++)
        {
            if((niz01[i - 1] == '0' && niz01[i] == '1') || niz01[0] == '1')
            {
                isplativost1 = cena;
                mini = isplativost1;
                l = i;
                for(j = 0; j < cena; j++)
                {
                    if(niz01[i + j] == '0') isplativost1++;
                }
                for(j = i + cena; j < n; j++)
                {
                    if(niz01[j] == '0') isplativost1++;
                    else isplativost1--;
                    if(isplativost1 <= mini)
                    {
                        l = i;
                        d = j;
                        mini = isplativost1;
                    }
                }
                if(mini < cena)
                {
                    c += cena;
                    for(r = l; r <= d; r++)
                    {
                        if(niz01[r] == '0') niz01[r] = '1';
                        else niz01[r] = '0';
                    }
                    mini = 0;
                }
                else
                {
                    for(i = 0; i < n; i++)
                    {
                        if(niz01[i] == '1')
                        {
                            niz01[i] = '0';
                            c++;
                        }
                    }
                    mini = cena;
                }
            }

        }
        return c;
    }
}

int main()
{
    long long par_l, par_r, cena, n, q, j, i, niz[20000];
    string niz01, niz01_copy;
    cin >> n >> cena >> q >> niz01;
    niz01_copy = niz01;
    for(i = 0; i < q; i++)
    {
        cin >> par_l >> par_r;
        for(j = par_l; j <= par_r; j++)
        {
            niz01_copy[j - 1] = (niz01_copy[j - 1] == '1') ? '0' : '1';
        }
        niz[i] = zamena(n, niz01_copy, cena);
        //cout << niz01_copy << endl;
    }
    for(i = 0; i < q; i++)
    {
        cout << niz[i] << endl;
    }
}